/**********************************************************************
 *
 * maptools.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: maptools.h 194 1999-03-09 20:53:14Z rjmcnab $
 *
 *********************************************************************/


#ifndef MAPTOOLS_H
#define MAPTOOLS_H


#include "gsdlconf.h"
#include "text_t.h"

// stringmap is a mapping which remembers the original order 
// of the map, but is very fast to look up.
class stringmap {
protected:
  text_tarray fromorder;
  text_tmap mapfrom;

public:
  void clear ();

  void importmap (const text_tarray &maparray);
  void exportmap (text_tarray &maparray) const;

  void getfromarray (text_tarray &fromarray) const;
  void gettoarray (text_tarray &toarray) const;
  
  bool fromexists (const text_t &from) const;
  bool toexists (const text_t &to) const;

  // from2to and to2from return false if the key (the "from"
  // field or the "to" field) cannot be found
  bool from2to (const text_t &from, text_t &to) const;
  bool to2from (const text_t &to, text_t &from) const;
};


// a few useful functions used by stringmap
void splitmapentry (const text_t &map, text_t &from, text_t &to);
void joinmapentry (const text_t &from, const text_t &to, text_t &map);


#endif
