/**********************************************************************
 *
 * queryfilter.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: queryfilter.h 327 1999-07-01 03:59:54Z rjmcnab $
 *
 *********************************************************************/


#ifndef QUERYFILTER_H
#define QUERYFILTER_H


#include "gsdlconf.h"
#include "text_t.h"
#include "comtypes.h"
#include "filter.h"
#include "infodbclass.h"
#include "maptools.h"
#include "mgsearch.h"


class queryfilterclass : public filterclass {
protected:
  stringmap indexmap;
  stringmap subcollectionmap;
  stringmap languagemap;

  text_t gdbm_filename;
  gdbmclass *gdbmptr;
  
  mgsearchclass *mgsearchptr;

  // do aditional query processing
  virtual void post_process (const queryparamclass &queryparams, const text_t &index,
			     queryresultsclass &queryresults);
  
public:
  queryfilterclass ();
  virtual ~queryfilterclass ();

  // the gdbmptr remains the responsability of the calling code
  void set_gdbmptr (gdbmclass *thegdbmptr) {gdbmptr=thegdbmptr;}

  // the mgsearchptr remains the responsability of the calling code
  void set_mgsearchptr (mgsearchclass *themgsearchptr) {mgsearchptr=themgsearchptr;}

  void configure (const text_t &key, const text_tarray &cfgline);
  bool init (ostream &logout);
  text_t get_filter_name () {return "QueryFilter";}
  void filter (const FilterRequest_t &request,
	       FilterResponse_t &response,
	       comerror_t &err, ostream &logout);
};


#endif
