/**********************************************************************
 *
 * formattools.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: formattools.h 347 1999-07-07 05:49:35Z sjboddie $
 *
 *********************************************************************/


#ifndef FORMATTOOLS_H
#define FORMATTOOLS_H

#include "text_t.h"
#include "comtypes.h"

enum command_t {comIf, comOr, comMeta, comText, comLink, comEndLink};
enum pcommand_t {pNone, pImmediate, pTop, pIndex, pAll};
enum dcommand_t {dMeta};

struct metadata_t {
  void clear();
  metadata_t () {clear();}

  int metaindex;
  pcommand_t parentcommand;
  int parentindex;
  text_t parentoptions;
};

struct decision_t {
  void clear();
  decision_t () {clear();}

  dcommand_t command;
  metadata_t meta;
};

struct format_t {
  void clear();
  format_t () {clear();}

  command_t command;
  decision_t decision;
  text_t text;
  metadata_t meta;
  format_t *nextptr;
  format_t *ifptr;
  format_t *elseptr;
  format_t *orptr;
};


text_t get_or (const ResultDocInfo_t &docinfo, format_t *orptr);

text_t get_if (const ResultDocInfo_t &docinfo, const decision_t &decision,
	       format_t *ifptr, format_t *elseptr);



bool parse_string (const text_t &formatstring, format_t *formatlistptr, 
		   text_tarray &metadata, bool &getParents, 
		   text_tmap &metamap, int &metacount);


bool parse_action (text_t::const_iterator &here, const text_t::const_iterator &end, 
		   format_t *formatlistptr, text_tarray &metadata, bool &getParents,
		   text_tmap &metamap, int &metacount);


bool parse_formatstring (const text_t &formatstring, format_t *formatlistptr, 
			 text_tarray &metadata, bool &getParents);

text_t get_formatted_string (const ResultDocInfo_t &docinfo, format_t *formatlistptr);

text_t format_string (const ResultDocInfo_t &docinfo, format_t *formatlistptr);

void get_parent_options (text_t &instring, metadata_t &metaoption);

bool parse_meta (text_t &meta, int &count, format_t *formatlistptr,
		 text_tarray &metadata, bool &getParents, text_tmap &metamap);

bool parse_meta (text_t &meta, int &count, decision_t &decision,
		 text_tarray &metadata, bool &getParents, text_tmap &metamap);


text_t get_meta (const ResultDocInfo_t &docinfo, const metadata_t &meta);


#endif
